"use strict";
// tslint:disable-next-line:no-reference
/// <reference path="../untyped.d.ts" />
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = require("assert");
const await_to_ts_1 = require("await-to-ts");
const lib_1 = require("../lib");
const issuerID = 'BANKNL2Y';
const acquirerID = '0030';
// const _ID = '000000000001'
// const transactionID = '0030000020088521'
// const merchantReference = `${acquirerID}${_ID}` // uuid().replace(/-/g, '')
const TEST_ENTRANCE_CODES = {
    success: `succesHIO100OIHtest`,
    cancelled: `cancelledHIO200OIHtest`,
    expiredEntranceCode: `expiredHIO300OIHtest`,
    openEntranceCode: `openHIO400OIHtest`,
    failureEntranceCode: `failureHIO500OIHtest`,
};
function executeFlow(entranceCode) {
    return __awaiter(this, void 0, void 0, function* () {
        // tslint:disable-next-line:no-console
        console.log(`
  executeFlow - entranceCode #${entranceCode}

  DIRECTORY REQUEST
  ${lib_1.formatDirectoryProtocolXML()}

  TRANSACTION REQUEST
  ${lib_1.formatTransactionProtocolXML(issuerID, entranceCode)}

  STATUS REQUEST
  ${lib_1.formatStatusProtocolXML(entranceCode)}
  `);
        const [err0, directoryResponse] = yield await_to_ts_1.default(lib_1.getDirectoryResponse());
        assert_1.ifError(err0);
        // tslint:disable:no-console
        console.log('Issuers', directoryResponse.Directory.Country.countryNames, directoryResponse.Directory.Country.Issuer);
        const [err1, transactionResponse] = yield await_to_ts_1.default(lib_1.getTransactionResponse(issuerID, entranceCode));
        assert_1.ifError(err1);
        console.log('transaction response', transactionResponse);
        console.log(`
  TransactionID: ${transactionResponse.Transaction.transactionID}
  IssuerAuthenticationURL: ${transactionResponse.Issuer.issuerAuthenticationURL}
  `);
        const [err2, statusResponse] = yield await_to_ts_1.default(lib_1.getStatusResponse(transactionResponse.Transaction.transactionID));
        assert_1.ifError(err2);
        console.log('status response', statusResponse);
        process.exit(0);
    });
}
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        for (const entranceCode of Object.values(TEST_ENTRANCE_CODES)) {
            const [err, res] = yield await_to_ts_1.default(executeFlow(entranceCode));
            assert_1.ifError(err);
        }
    });
}
main().catch(console.error);
//# sourceMappingURL=index.js.map