"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const pretty_data_1 = require("pretty-data");
const constants_1 = require("./constants");
const idin_protocol_1 = require("./idin-protocol");
function formatDirectoryProtocolXML() {
    const xml = pretty_data_1.pd.xmlmin(`
    <?xml version="1.0" encoding="UTF-8"?>
    <DirectoryReq
    version="1.0.0"
    productID="NL:BVN:BankID:1.0"
    xmlns="http://www.betaalvereniging.nl/iDx/messages/Merchant-Acquirer/1.0.0"
    xmlns:ds="http://www.w3.org/2000/09/xmldsig#" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
      <createDateTimestamp>${new Date().toISOString()}</createDateTimestamp>
      <Merchant>
        <merchantID>${constants_1.MERCHANT_ID}</merchantID>
        <subID>${constants_1.MERCHANT_SUBID}</subID>
      </Merchant>
    </DirectoryReq>
  `);
    return idin_protocol_1.signXML(xml);
}
exports.formatDirectoryProtocolXML = formatDirectoryProtocolXML;
//# sourceMappingURL=directory-protocol.js.map