"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const xml_crypto_1 = require("xml-crypto");
const xmldom_1 = require("xmldom");
const constants_1 = require("./constants");
function signXML(xml, selfVerify = false) {
    const sig = new xml_crypto_1.SignedXml();
    const entryPoint = '/*';
    const transformers = ['http://www.w3.org/2000/09/xmldsig#enveloped-signature', 'http://www.w3.org/2001/10/xml-exc-c14n#'];
    const xmlenc = 'http://www.w3.org/2001/04/xmlenc#sha256';
    const signatureAlgorithm = 'http://www.w3.org/2001/04/xmldsig-more#rsa-sha256';
    const MyKeyInfo = function (key) {
        this.getKeyInfo = (privateKey, prefix) => {
            return `<KeyName>${constants_1.PUBLIC_KEY_FINGERPRINT}</KeyName>`;
        };
        // this.getKey = (keyInfo: any) => {
        //   return readFileSync('cert.pem')
        // }
    };
    sig.addReference(entryPoint, transformers, xmlenc, void 0, void 0, void 0, true);
    sig.keyInfoProvider = new MyKeyInfo(constants_1.PRIVATE_KEY);
    sig.signatureAlgorithm = signatureAlgorithm;
    sig.signingKey = constants_1.PRIVATE_KEY;
    sig.computeSignature(xml);
    const res = sig.getSignedXml();
    selfVerify ? verifyOwnSignature(res, xml) : Function.prototype();
    return res;
}
exports.signXML = signXML;
function verifyOwnSignature(res, xml) {
    const doc = new xmldom_1.DOMParser().parseFromString(res);
    const signature = xml_crypto_1.xpath(doc, '//*[local-name(.)=\'Signature\' and namespace-uri(.)=\'http://www.w3.org/2000/09/xmldsig#\']')[0];
    const sx = new xml_crypto_1.SignedXml();
    sx.keyInfoProvider = new xml_crypto_1.FileKeyInfo('cert.pem');
    sx.loadSignature(signature);
    const result = sx.checkSignature(xml);
    /* istanbul ignore next */
    if (!result) {
        throw new Error(sx.validationErrors);
    }
}
exports.verifyOwnSignature = verifyOwnSignature;
//# sourceMappingURL=idin-protocol.js.map