"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = require("assert");
const await_to_ts_1 = require("await-to-ts");
const es6_promisify_1 = require("es6-promisify");
require("isomorphic-fetch");
const xml_crypto_1 = require("xml-crypto");
const xml_encryption_1 = require("xml-encryption");
const xml_js_1 = require("xml-js");
const xmldom_1 = require("xmldom");
const constants_1 = require("./constants");
const directory_protocol_1 = require("./directory-protocol");
const status_protocol_1 = require("./status-protocol");
const transaction_protocol_1 = require("./transaction-protocol");
const DEFAULT_FETCH_CONFIG = {
    method: 'POST',
};
const DECRYPT_OPTIONS = {
    key: constants_1.PRIVATE_KEY,
};
const MyKeyInfo = function (key1) {
    // this.getKeyInfo = (privateKey: any, prefix: string) => {
    //   return `<KeyName>5ef3776d972e9cdf45689eb0c316e13c1ece412b</KeyName>`
    // }
    this.getKey = (keyInfo) => {
        return `-----BEGIN CERTIFICATE-----
MIIDzjCCAragAwIBAgIGAVdRyiTvMA0GCSqGSIb3DQEBCwUAMIGKMQswCQYDVQQG
EwJOTDEWMBQGA1UECBMNTm9vcmQgSG9sbGFuZDESMBAGA1UEBxMJQW1zdGVyZGFt
MRkwFwYDVQQLExBJbnRlcm5ldCBCYW5raW5nMRswGQYDVQQKExJBQk4gQU1STyBC
YW5rIE4uVi4xFzAVBgNVBAMTDnd3dy5hYm5hbXJvLm5sMB4XDTE2MDkyMjEyMDYy
NFoXDTE5MDkyMjEyMDYyNFowgYoxCzAJBgNVBAYTAk5MMRYwFAYDVQQIEw1Ob29y
ZCBIb2xsYW5kMRIwEAYDVQQHEwlBbXN0ZXJkYW0xGTAXBgNVBAsTEEludGVybmV0
IEJhbmtpbmcxGzAZBgNVBAoTEkFCTiBBTVJPIEJhbmsgTi5WLjEXMBUGA1UEAxMO
d3d3LmFibmFtcm8ubmwwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQCd
EPU6zMZWeRA4HJrmd6BOletvBJJ7E8aTVwQ8X4Y3ulEjghk0HjAYN7GzHIu9fyTX
HEYWr1ewQZyqzzv4o6PfA/k3qRoLpqDjRWMQV38n/Bz+w3q50MT9HyC9+SJ4oWL3
FkPMyI0iOtgXLvSkQ9eUVzCQx2rgpftOXfcdaWiJrELwCT1GTxputqDE6pThfBze
P38uPbcdDAVltOUKLS/uH7xweTpKamA+VAozRlDm4JzOG8vrHgjHztfwpW5+sv19
gDje7bOWFDgqK+HNh4XHCW5OsfvXO4BoYvUVJZCpdLGsy62D8k3HDbmlnB+As4qj
LBM32CGVCvjLEsf+pb9JAgMBAAGjODA2MAwGA1UdEwEB/wQCMAAwDgYDVR0PAQH/
BAQDAgWgMBYGA1UdJQEB/wQMMAoGCCsGAQUFBwMBMA0GCSqGSIb3DQEBCwUAA4IB
AQB5hj4RSq0XGqe0HIKL4sj+E40pECas7YEh0dKm6ZowFqJZy4+B8T3uztA348va
3yrPTQx7N4vBLupnrQQ2dX+Ut1LmavTDIpQDvHW1X7EoGBI7JWY3gIX/eUjTnEDJ
qn1U9zVTMEvypfxoHIM5UbyCf+b2eitgqPqHp4r3TyPmNEGUgvleofUTlPc8v8UF
oq4Vtm4mhTLcpi5A/jOdjTkEiHRsivzRyeSXpYszL6Mo6Z7yrxRjstUf3Pw467Ii
Jur8mQC/7X5ir8N7rS9Dp8waYRt8qbgf6xXfG6HALungkpiM11WQLuNoPKwhMZAW
VmT926W9yWIvNndcaHyseijI
-----END CERTIFICATE-----`;
    };
};
const DOM = new xmldom_1.DOMParser();
const XML = new xml_crypto_1.SignedXml();
XML.signatureAlgorithm = 'http://www.w3.org/2001/04/xmldsig-more#rsa-sha512';
XML.keyInfoProvider = new MyKeyInfo('iDIN_ABN_PROD_merchant.cer');
function fetchResponse(payload, routingService = constants_1.ROUTING_ENDPOINT) {
    if (!routingService) {
        return Promise.reject(new Error('ROUNTING_ENDPOINT is not defined.'));
    }
    const config = Object.assign({}, DEFAULT_FETCH_CONFIG, { body: payload });
    return fetch(routingService, config)
        .then((res) => res.text())
        .then((res) => verifySignature(res));
}
exports.fetchResponse = fetchResponse;
function fetchDirectoryResponse() {
    const payload = directory_protocol_1.formatDirectoryProtocolXML();
    return fetchResponse(payload);
}
exports.fetchDirectoryResponse = fetchDirectoryResponse;
function verifySignature(signedXML) {
    return __awaiter(this, void 0, void 0, function* () {
        const doc = DOM.parseFromString(signedXML.trim());
        const signature = xml_crypto_1.xpath(doc, '//*[local-name(.)=\'Signature\' and namespace-uri(.)=\'http://www.w3.org/2000/09/xmldsig#\']');
        const lastSig = signature.pop();
        XML.loadSignature(lastSig);
        const result = XML.checkSignature(signedXML.trim());
        /* istanbul ignore next */
        if (!result) {
            // tslint:disable:no-console
            console.error(new Error(XML.validationErrors));
        }
        return signedXML;
    });
}
exports.verifySignature = verifySignature;
// tslint:disable:no-string-literal
function getDirectoryResponse() {
    return __awaiter(this, void 0, void 0, function* () {
        const payload = directory_protocol_1.formatDirectoryProtocolXML();
        const [err, res] = yield await_to_ts_1.default(fetchDirectoryResponse());
        assert_1.ifError(err);
        const parsed = JSON.parse(xml_js_1.xml2json(res, { compact: true }));
        console.log('diocane', res);
        return {
            createDateTimestamp: parsed['ns3:DirectoryRes']['ns3:createDateTimestamp']._text,
            Acquirer: {
                acquirerID: parsed['ns3:DirectoryRes']['ns3:Acquirer']['ns3:acquirerID']._text,
            },
            Directory: {
                directoryDateTimestamp: parsed['ns3:DirectoryRes']['ns3:Directory']['ns3:directoryDateTimestamp']._text,
                Country: {
                    countryNames: parsed['ns3:DirectoryRes']['ns3:Directory']['ns3:Country']['ns3:countryNames']._text,
                    Issuer: _parseIssuers(parsed['ns3:DirectoryRes']['ns3:Directory']['ns3:Country']['ns3:Issuer']),
                },
            },
        };
    });
}
exports.getDirectoryResponse = getDirectoryResponse;
function _parseIssuers(issuers) {
    const parse = (issuer) => {
        return {
            issuerID: issuer['ns3:issuerID']._text,
            issuerName: issuer['ns3:issuerName']._text,
        };
    };
    return Array.isArray(issuers) ? issuers.map(parse) : [parse(issuers)];
}
function fetchTransactionResponse(issuerID, transactionID, requestedService) {
    const payload = transaction_protocol_1.formatTransactionProtocolXML(issuerID, transactionID, requestedService);
    return fetchResponse(payload);
}
exports.fetchTransactionResponse = fetchTransactionResponse;
function getTransactionResponse(issuerID, transactionID, requestedService) {
    return __awaiter(this, void 0, void 0, function* () {
        const [err, res] = yield await_to_ts_1.default(fetchTransactionResponse(issuerID, transactionID, requestedService));
        assert_1.ifError(err);
        const parsed = JSON.parse(xml_js_1.xml2json(res, { compact: true }));
        return {
            createDateTimestamp: parsed['ns3:AcquirerTrxRes']['ns3:createDateTimestamp']._text,
            Acquirer: {
                acquirerID: parsed['ns3:AcquirerTrxRes']['ns3:Acquirer']['ns3:acquirerID']._text,
            },
            Issuer: {
                issuerAuthenticationURL: parsed['ns3:AcquirerTrxRes']['ns3:Issuer']['ns3:issuerAuthenticationURL']._text,
            },
            Transaction: {
                transactionID: parsed['ns3:AcquirerTrxRes']['ns3:Transaction']['ns3:transactionID']._text,
                transactionCreateDateTimestamp: parsed['ns3:AcquirerTrxRes']['ns3:Transaction']['ns3:transactionCreateDateTimestamp']._text,
            },
        };
    });
}
exports.getTransactionResponse = getTransactionResponse;
function fetchStatusResponse(transactionID) {
    const payload = status_protocol_1.formatStatusProtocolXML(transactionID);
    return fetchResponse(payload);
}
exports.fetchStatusResponse = fetchStatusResponse;
function getStatusResponse(transactionID) {
    return __awaiter(this, void 0, void 0, function* () {
        const xpathQuery = '//*[local-name(.)=\'EncryptedData\']';
        const [err, statusResponse] = yield await_to_ts_1.default(fetchStatusResponse(transactionID));
        assert_1.ifError(err);
        const xpathRes = xml_crypto_1.xpath(new xmldom_1.DOMParser().parseFromString(statusResponse), xpathQuery);
        const promises = xpathRes.map((res) => es6_promisify_1.promisify(xml_encryption_1.decrypt)(res.toString(), DECRYPT_OPTIONS));
        const [err1, attributes] = yield await_to_ts_1.default(Promise.all(promises));
        assert_1.ifError(err1);
        const parsed = JSON.parse(xml_js_1.xml2json(statusResponse, { compact: true }));
        return {
            createDateTimestamp: parsed['awidxma:AcquirerStatusRes']['awidxma:createDateTimestamp']._text,
            Acquirer: {
                acquirerID: parsed['awidxma:AcquirerStatusRes']['awidxma:Acquirer']['awidxma:acquirerID']._text,
            },
            Transaction: {
                transactionID: parsed['awidxma:AcquirerStatusRes']['awidxma:Transaction']['awidxma:transactionID']._text,
                status: parsed['awidxma:AcquirerStatusRes']['awidxma:Transaction']['awidxma:status']._text,
                statusDateTimestamp: parsed['awidxma:AcquirerStatusRes']['awidxma:Transaction']['awidxma:statusDateTimestamp']._text,
                Response: {
                    TransactionID: parsed['awidxma:AcquirerStatusRes']['awidxma:Transaction']['awidxma:container']['saml2p:Response']._attributes.ID,
                    EntranceCode: parsed['awidxma:AcquirerStatusRes']['awidxma:Transaction']['awidxma:container']['saml2p:Response']._attributes.InResponseTo,
                    StatusCode: parsed['awidxma:AcquirerStatusRes']['awidxma:Transaction']['awidxma:container']['saml2p:Response']['saml2p:Status']['saml2p:StatusCode']._attributes.Value.split('status:')[1],
                    IssuerID: parsed['awidxma:AcquirerStatusRes']['awidxma:Transaction']['awidxma:container']['saml2p:Response']['saml2:Assertion']['saml2:Issuer']._text,
                    Attributes: Object.assign({}, ...attributes.map((a) => JSON.parse(xml_js_1.xml2json(a, { compact: true }))).map((a) => ({
                        [(a['saml2:NameID'] && 'NameID') || a['saml2:Attribute']._attributes.Name.split('consumer.')[1]]: (a['saml2:NameID'] && a['saml2:NameID']._text) || a['saml2:Attribute']['saml2:AttributeValue']._text,
                    }))),
                },
            },
        };
    });
}
exports.getStatusResponse = getStatusResponse;
//# sourceMappingURL=idin-request.js.map